

from edgeiq.base_service import BaseService as bs
from edgeiq import bounding_box



class ObjectDetectionPrediction(bounding_box.BoundingBoxPrediction):
    """A single prediction from :class:`ObjectDetection`."""
    def __init__(self, box, confidence, label, index):
        pass

    def __eq__(self, other):
        pass

    @property
    def label(self):
        pass

    @label.setter
    def label(self, label):
        pass

    @property
    def index(self):
        pass

    def __repr__(self):
        pass

class ObjectDetectionResults:
    """
    All the results of object detection from :class:`ObjectDetection`.

    Predictions are stored in sorted order, with descending order of
    confidence.
    """
    def __init__(self, predictions, duration, image, **kwargs):
        pass

    @property
    def duration(self):
        pass

    @property
    def predictions(self):
        pass

    def __repr__(self):
        pass

class ObjectDetection(bs):
    """
    Analyze and discover objects within an image.

    Typical usage::

        obj_detect = edgeiq.ObjectDetection(
                'alwaysai/ssd_mobilenet_v1_coco_2018_01_28')
        obj_detect.load(engine=edgeiq.Engine.DNN)

        <get image>
        results = obj_detect.detect_objects(image, confidence_level=.5)
        image = edgeiq.markup_image(
                image, results.predictions, colors=obj_detect.colors)

        for prediction in results.predictions:
                text.append("{}: {:2.2f}%".format(
                    prediction.label, prediction.confidence * 100))

    :type model_id: string
    :param model_id: The ID of the model you want to use for object detection.
    """
    def __init__(self, model_id):
        pass

    def detect_objects(self, image, confidence_level=.3, overlap_threshold=.3):
        pass

