from edgeiq import Accelerator, Engine, base_service
import logging
import cv2


class PoseEstimation(base_service.BaseService):
    """
    Find poses within an image.

    Typical usage::

        pose_estimator = edgeiq.PoseEstimation("alwaysai/human-pose")
        pose_estimator.load(engine=edgeiq.Engine.DNN)

        <get image>
        results = pose_estimator.estimate(image)

        for ind, pose in enumerate(results.poses):
                    print('Person {}'.format(ind))
                    print('-'*10)
                    print('Key Points:')
                    for key_point in pose.key_points:
                        print(str(key_point))
        image = results.draw_poses(image)

    :type model_id: string
    :param model_id: The ID of the model you want to use for pose estimation.
    """
    def __init__(self, model_id):
        pass

    def estimate(self, image):
        pass

if __name__ == '__main__':
    logging.basicConfig(level=logging.DEBUG)
    hs = PoseEstimation('alwaysai/human_pose')
    hs.load(Engine.DNN_OPENVINO, Accelerator.MYRIAD)
    image_ = cv2.imread('soccer2.jpg')
    pose_result = hs.estimate(image_)
    pose_result.draw_poses(image_)
    cv2.imwrite('pointers.png', image_)
