import edgeiq
import platform

if platform.system() in edgeiq.REALSENSE_SUPPORTED_OS:
    pass

def enumerate_realsense_cameras():
    pass

class RealSense(object):
     """
     A set of methods that can be used with a Realsense camera(s) for getting
     the distances to objects, capturing regions of interest based on
     distance, displaying video streams and depth maps.  Only usb 3.0 connections
     are supported.

     Typical usage::

        try:
            with edgeiq.RealSense() as video_stream,
                    edgeiq.Streamer() as streamer:
                time.sleep(2.0)

        <get distances to objects>
        video_stream.start()

        while True:
            depth_image, color_image = video_stream.read()
            results = obj_detect.detect_objects(color_image, confidence_level=.5)

            for prediction in results.predictions:
                    distance = video_stream.compute_object_distance(prediction.box,depth_image)
    :type device_serial_number: string
    :param device_serial_number: The serial number of the realsense device you
                                 want to use obtained from enumerate_realsense_cameras()
                                 function
     """
     def __init__(self, device_serial_number=None):
         pass

     def start(self):
         pass

     def read(self):
         pass

     def render_depth_image(self, depth_image):
         pass

     def roi(self, depth_image, color_image, min=None, max=None, shade=160):
         pass

     def compute_object_distance(self, box, depth_image):
         pass

     def compute_distance_between_objects(self, box1, box2):
         pass

     def __enter__(self):
         pass

     def __exit__(self, type, value, traceback):
         pass

     def __del__(self):
        pass

     def stop(self):
         pass

